Type PxBodyFromMesh
	Field physMesh_body%
	Field physMesh_mesh%
End Type

Function GetBodyFromMesh(entity%)
	For i=1 To CountChildren(entity)
			child% = GetChild (entity, i)
			child_name$ = EntityName (child)
		
			child_dimens_x# = MeshWidth #(child)*0.5*EntityScaleX#(child)
			child_dimens_y# = MeshHeight #(child)*0.5*EntityScaleY#(child)
			child_dimens_z# = MeshDepth#(child)*0.5*EntityScaleZ#(child)

			child_angle_pitch# = EntityPitch#(child)
			child_angle_yaw# = EntityYaw#(child)
			child_angle_roll# = EntityRoll#(child)
			
			If Instr(child_name$,"\cu",1) <> 0
				frm.PxBodyFromMesh = New PxBodyFromMesh
				FirstNumber_massName% = Instr(child_name, "\m", 1)
				LastNumber_massName% = Instr(child_name, "\", FirstNumber_massName + 2)
				Lenght_massName% = LastNumber_massName - FirstNumber_massName - 2
				Last_massName$ = Mid(child_name, FirstNumber_massName+2, Lenght_massName)
				mass# = Float(Last_massName$)

				MoveEntity child,0,child_dimens_y#,0
				frm\physMesh_body = PxBodyCreateCube(child_dimens_x#, child_dimens_y#, child_dimens_z#, mass#)
				pxBodySetPosition (frm\physMesh_body, EntityX(child,1), EntityY(child,1), EntityZ(child,1))
				pxBodySetRotation (frm\physMesh_body, EntityPitch (child), EntityYaw (child), EntityRoll (child))
				frm\physMesh_mesh = child
				MoveEntity child,0,-child_dimens_y#,0
				RotateEntity child,0,0,0
				PositionMesh child,0,-MeshHeight #(child)*0.5,0
				RotateEntity child, child_angle_pitch, child_angle_yaw, child_angle_roll	

			Else If Instr(child_name$,"\sp",1) <> 0
				frm.PxBodyFromMesh = New PxBodyFromMesh
				FirstNumber_massName% = Instr(child_name, "\m", 1)
				LastNumber_massName% = Instr(child_name, "\", FirstNumber_massName + 2)
				Lenght_massName% = LastNumber_massName - FirstNumber_massName - 2
				Last_massName$ = Mid(child_name, FirstNumber_massName+2, Lenght_massName)
				mass# = Float(Last_massName$)
			
				frm\physMesh_body = PxBodyCreateSphere(child_dimens_x#, mass#)
				pxBodySetPosition (frm\physMesh_body, EntityX(child,1), EntityY(child,1), EntityZ(child,1))
				pxBodySetRotation (frm\physMesh_body, EntityPitch (child), EntityYaw (child), EntityRoll (child))
				frm\physMesh_mesh = child
	
			Else If Instr(child_name$,"\cap",1) <> 0
				frm.PxBodyFromMesh = New PxBodyFromMesh
				FirstNumber_massName% = Instr(child_name, "\m", 1)
				LastNumber_massName% = Instr(child_name, "\", FirstNumber_massName + 2)
				Lenght_massName% = LastNumber_massName - FirstNumber_massName - 2
				Last_massName$ = Mid(child_name, FirstNumber_massName+2, Lenght_massName)
				mass# = Float(Last_massName$)

				MoveEntity child,0,child_dimens_y#,0
				frm\physMesh_body = pxBodyCreateCapsule(child_dimens_y#*1.7, child_dimens_x#, mass#)
				pxBodySetPosition (frm\physMesh_body, EntityX(child,1), EntityY(child,1), EntityZ(child,1))
				pxBodySetRotation (frm\physMesh_body, EntityPitch (child), EntityYaw (child), EntityRoll (child))
				frm\physMesh_mesh = child
				MoveEntity child,0,-child_dimens_y#,0
				RotateEntity child,0,0,0
				PositionMesh child,0,-MeshHeight #(child)*0.5,0
				RotateEntity child, child_angle_pitch, child_angle_yaw, child_angle_roll
				
			Else If Instr(child_name$,"\hul",1) <> 0
				frm.PxBodyFromMesh = New PxBodyFromMesh
				FirstNumber_massName% = Instr(child_name, "\m", 1)
				LastNumber_massName% = Instr(child_name, "\", FirstNumber_massName + 2)
				Lenght_massName% = LastNumber_massName - FirstNumber_massName - 2
				Last_massName$ = Mid(child_name, FirstNumber_massName+2, Lenght_massName)
				mass# = Float(Last_massName$)
			
 				frm\physMesh_body = BodyCreateHull%(child, mass)
				frm\physMesh_mesh = child
				pxBodySetPosition (frm\physMesh_body, EntityX(child,1), EntityY(child,1), EntityZ(child,1))
				pxBodySetRotation (frm\physMesh_body, EntityPitch (child), EntityYaw (child), EntityRoll (child))

			Else If Instr(child_name$,"\trm",1) <> 0
				frm.PxBodyFromMesh = New PxBodyFromMesh
				FirstNumber_massName% = Instr(child_name, "\m", 1)
				LastNumber_massName% = Instr(child_name, "\", FirstNumber_massName + 2)
				Lenght_massName% = LastNumber_massName - FirstNumber_massName - 2
				Last_massName$ = Mid(child_name, FirstNumber_massName+2, Lenght_massName)
				mass# = Float(Last_massName$)

				FirstNumber_massName% = Instr(child_name, "\n", 1)
				LastNumber_massName% = Instr(child_name, "\", FirstNumber_massName + 2)
				Lenght_massName% = LastNumber_massName - FirstNumber_massName - 2
				Last_massName$ = Mid(child_name, FirstNumber_massName+2, Lenght_massName)
				pmap_file_name$ = Last_massName$

				in_mesh = InitialTriMesh%(child, pmap_file_name$)
				frm\physMesh_body = pxCreateTriMeshFromPmap(in_mesh, mass)
				frm\physMesh_mesh = child
				pxBodySetPosition (frm\physMesh_body, EntityX(child,1), EntityY(child,1), EntityZ(child,1))
				pxBodySetRotation (frm\physMesh_body, EntityPitch (child), EntityYaw (child), EntityRoll (child))
			EndIf
		Next

End Function

Function Update_PxBodyFromMesh()
	For frm.PxBodyFromMesh = Each PxBodyFromMesh
          pxBodySetEntity(frm\physMesh_mesh, frm\physMesh_body)
	Next
End Function



Function BodyCreateHull%(mesh%, mass#)
	Local nsurf = CountSurfaces(mesh)
	Local nvert = 0
	For ns = 1 To nsurf
		Local surf = GetSurface(mesh,ns)
		nvert = nvert + CountVertices(surf)
	Next
	     vbank = CreateBank(nvert*4*3)
	nv = 0
	For ns = 1 To nsurf
		surf = GetSurface(mesh,ns)
		nvv = CountVertices(surf)
		For nvc = 0 To nvv - 1
			 PokeFloat vbank,nv*12+0,VertexX(surf,nvc)
			 PokeFloat vbank,nv*12+4,VertexY(surf,nvc)
			 PokeFloat vbank,nv*12+8,VertexZ(surf,nvc)
			nv = nv+1
		Next
	Next
	Local bbb%= pxBodyCreateHull(vbank, nvert, mass)
	FreeBank vbank
	Return bbb
End Function


Function InitialTriMesh(mesh%,file_name$)
	nsurf = CountSurfaces(mesh)
	nvert = 0
	nface=0
	For ns = 1 To nsurf
		Local surf = GetSurface(mesh,ns)
		nface = nface+CountTriangles(surf)
		nvert = nvert +CountVertices(surf)
	Next

	fbank = CreateBank(nface*4*3)
	nf = 0
	vbank = CreateBank(nvert*4*3)
	nv = 0
	For ns = 1 To nsurf
		surf = GetSurface(mesh,ns)
		nfv = CountTriangles(surf)
		For nfc = 0 To nfv -1
			PokeInt fbank,nf*12+0,TriangleVertex(surf,nfc,0)
			PokeInt fbank,nf*12+4,TriangleVertex(surf,nfc,1)
			PokeInt fbank,nf*12+8,TriangleVertex(surf,nfc,2)
			nf=nf+1
		Next

		nvv = CountVertices(surf)
		For nvc = 0 To nvv - 1
			PokeFloat vbank,nv*12+0,VertexX(surf,nvc)
			PokeFloat vbank,nv*12+4,VertexY(surf,nvc)
			PokeFloat vbank,nv*12+8,VertexZ(surf,nvc)
			nv = nv+1
		Next
	Next
	bbb%=pxCreateTriMeshPmap(vbank, fbank, nvert, nface, file_name$,64)
	FreeBank vbank
	FreeBank fbank
	Return bbb%
End Function



Function EntityScaleX#(ent%) 
 row=0
 el1# = GetMatElement(ent,row,0) 
 el2# = GetMatElement(ent,row,1) 
 el3# = GetMatElement(ent,row,2) 
 Return Sqr(el1*el1+el2*el2+el3*el3) 
End Function

Function EntityScaleY#(ent%) 
 row=1
 el1# = GetMatElement(ent,row,0) 
 el2# = GetMatElement(ent,row,1) 
 el3# = GetMatElement(ent,row,2) 
 Return Sqr(el1*el1+el2*el2+el3*el3) 
End Function

Function EntityScaleZ#(ent%) 
 row=2
 el1# = GetMatElement(ent,row,0) 
 el2# = GetMatElement(ent,row,1) 
 el3# = GetMatElement(ent,row,2) 
 Return Sqr(el1*el1+el2*el2+el3*el3) 
End Function

