
Graphics3D 800,600,32,2
SetBuffer BackBuffer()


;Lights
light01=CreateLight()
PositionEntity light01,0,60,-15
RotateEntity light01,30,0,0
AmbientLight 255,255,255

;Plane
plane=CreatePlane()
EntityColor plane,100,200,100
EntityAlpha plane, 0.5
m=CreateMirror ()

;Camera
Global cam=CreateCamera()
PositionEntity cam,0,35,-55
RotateEntity cam,30,0,0

tex = LoadTexture ("..\media\Logo.jpg")
;---------- Create Cloth Meshes----------

cloth_mesh = LoadMesh ("..\media\pol.b3d")
EntityTexture cloth_mesh,tex
PositionEntity cloth_mesh,0,30,0
EntityFX cloth_mesh,16
MeshHeight (cloth_mesh)
surf = GetSurface (cloth_mesh,1 )

;PX
PxCreateWorld(1, "key")					
pxSetGravity(0,-10,0)				



;------------ Create cloth--------------------------
cloth_body = pxCreateCloth(cloth_mesh, surf)

;---------------- Attach Cloth---------------------
pxClothAttachVertexToPos (cloth_body, 399, -10,30,10)
pxClothAttachVertexToPos (cloth_body, 440, 9,30,10)



Repeat

If KeyHit(57) Create_Px_Cube()

x#=0: y#=0: z#=0 
If KeyDown( 203 ) Then x#=-0.2 
If KeyDown( 205 ) Then x#=0.2 
If KeyDown( 208 ) Then y#=-0.2 
If KeyDown( 200 ) Then y#=0.2 
If KeyDown( 44 ) Then z#=-0.2 
If KeyDown( 30 ) Then z#=0.2
;If KeyDown( 2 ) Then ry = ry+1
;If KeyDown( 3 ) Then ry = ry-1 
RotateEntity cam,0,ry,0

MoveEntity cam,x#,y#,z#

time=MilliSecs ()
;-------Update cloth and World-------
	pxUpdateCloth()
	Update_Px_Cube()
	pxRenderPhysic(30,0)		
New_time=MilliSecs ()-time

If KeyHit (2) bbb=SaveCloth(cloth_body)
If KeyHit (3) bbb=LoadCloth(cloth_body)
If KeyHit (5) num = num+40
If KeyHit (6) num = num-40


UpdateWorld()
RenderWorld()
   frames=frames+1  
   If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()  
   Text 10,10,"FPS: "+fps1+"  DLL Time: "+ New_time
   Text 10,20,"1 - SAVE  "
   Text 10,30,"2 - LOAD  "

Flip 

Until KeyHit(1)
pxDestroyWorld()
End

Type Px_Cube
	Field cube_body%
	Field cube_mesh%
End Type

Function Create_Px_Cube()
   ocu.Px_Cube = New Px_Cube
		ocu\cube_body=PxBodyCreateCube(1,1,1, 3)
 		ocu\cube_mesh=CreateCube()
		ScaleEntity ocu\cube_mesh,1,1,1
		EntityColor ocu\cube_mesh,Rand(0,255),Rand(0,255),Rand(0,255) 
		pxBodySetPosition(ocu\cube_body,EntityX(cam)+Rand(-5,5),EntityY(cam)+Rand(-5,5),EntityZ(cam))
		pxBodySetRotation(ocu\cube_body,Rand(-90,90),Rand(-90,90),Rand(-90,90))

	  pxBodyAddForce(ocu\cube_body, 0, 0, 50, 2)
		
 End Function

 Function Update_Px_Cube()
	For ocu.Px_Cube = Each Px_Cube
         pxBodySetEntity(ocu\cube_mesh, ocu\cube_body)
	Next
End Function


Function SaveCloth(cloth%)

	Local nvert = 0
	nvert = pxClothGetNumVertices(cloth)
	vbank=CreateBank(nvert*4*3)
	pxClothGetVertexPos(cloth, vbank, nvert)
	
	fileout = WriteFile("ClothData.csev") 
	For nvc = 0 To nvert - 1
		WriteFloat( fileout, PeekFloat (vbank, nvc*12+0))
		WriteFloat( fileout, PeekFloat (vbank, nvc*12+4))
		WriteFloat( fileout, PeekFloat (vbank, nvc*12+8)) 
	Next
	CloseFile( fileout )

	Return bbb
End Function

Function LoadCloth(cloth%)

	Local nvert = 0
	nvert = pxClothGetNumVertices(cloth)
	filein = ReadFile("ClothData.csev")
	nvbank = CreateBank(nvert*4*3)
	
	For nvc = 0 To nvert - 1
		PokeFloat (nvbank, nvc*12+0, ReadFloat( filein))
		PokeFloat (nvbank, nvc*12+4, ReadFloat( filein))
		PokeFloat (nvbank, nvc*12+8, ReadFloat( filein))
	Next
	CloseFile( filein )
	pxClothSetVertexPos(cloth, nvbank, nvert)

	Return bbb
End Function

