;-------------------
;by MadMedic
;
;-----------------

Graphics3D 800,600,0,2
SetBuffer BackBuffer()

SetFont LoadFont("arial",16)
cam=CreateCamera()
PositionEntity cam,0,5,-10

CreateLight()

pxCreateWorld(0,"key")
pxSetGravity(0,-10,0)

contactmesh=CreateCone()
ScaleEntity contactmesh,0.1,0.1,0.1
EntityColor contactmesh,255,0,0
EntityOrder contactmesh,-100
HideEntity contactmesh



;Dynamic Body 1
DynMesh1=CreateCube()
EntityTexture DynMesh1,CreateTextTexture(64,"1")
DynBody1=pxBodyCreateCube(1,1,1,10)
pxBodySetPosition(DynBody1, 0, 10, 0)
pxBodySetBodyName(DynBody1, "DB 1")


;Dynamic Body 2
DynMesh2=CreateCube()
EntityTexture DynMesh2,CreateTextTexture(64,"2")
DynBody2=pxBodyCreateCube(1,1,1,10)
pxBodySetPosition(DynBody2, 5, 10, 0)
pxBodySetRotation(DynBody2, 0,46, 0)
pxBodySetFlagCollision(dynbody2, 1)
pxBodySetFlagContacttable(dynbody2, 0)
pxBodySetBodyName(DynBody2, "DB 2")


;Static Body
StMesh=CreateCube()
ScaleMesh StMesh,20,1,20
EntityTexture StMesh,CreateTextTexture(256,"Static cube")
StBody=pxBodyCreateCube(20,1,20,0)
pxBodySetPosition(StBody, 0,1.1, 0)
pxBodySetBodyName(StBody, "SB")
pxBodySetEntity(StMesh,StBody)


timer=CreateTimer(15)
ContactPivot=CreatePivot()

Repeat

;WaitTimer timer
	If KeyHit(1) Exit

	If KeyDown (205) pxBodyAddForce(DynBody2,7,0,0, 1)
	If KeyDown (203) pxBodyAddForce(DynBody2,-7,0,0, 1)
	If KeyDown (200) pxBodyAddForce(DynBody2,0,0,7, 1)
	If KeyDown (208) pxBodyAddForce(DynBody2,0,0,-7, 1)
	If KeyDown (57) pxBodyAddForce(DynBody2,0,10,0, 1)

	pxRenderPhysic(60,0)
	
	pxBodySetEntity(DynMesh1,DynBody1)
	pxBodySetEntity(DynMesh2,DynBody2)
	pxBodySetSleepWakeUp(DynBody1, 1)
	pxBodySetSleepWakeUp(DynBody2, 2)

	;clear old contacts
	For i=1 To CountChildren(ContactPivot)
		FreeEntity GetChild(ContactPivot,i)
	Next
	
	contacts=pxGetContacts%(DynBody2)
	pl = pl+1
	;show contacts
;	For contactnumber=0 To contacts-1
;		;contact point
;		NewCone=CopyEntity(contactmesh,ContactPivot)
;		PositionEntity NewCone,pxContactGetPointX#(DynBody2, contactnumber),pxContactGetPointY#(DynBody2, contactnumber),pxContactGetPointZ#(DynBody2, contactnumber)
;		AlignToVector NewCone,pxContactGetPointNX#(DynBody2, contactnumber),pxContactGetPointNY#(DynBody2, contactnumber),pxContactGetPointNZ#(DynBody2, contactnumber),2
;	Next


	UpdateWorld
	RenderWorld


	
	;print contact info
	contacts=pxGetContacts%(DynBody1)
	pl=pl+1
	Text 10,10,"Dynamic body 1. Contacts: "+contacts
;	For contactnumber=0 To contacts-1
;		ForceN#=pxContactGetForceNY#(DynBody1, contactnumber)
;		Text 10,30+contactnumber*20,"FN in con# "+contactnumber+" is "+ForceN#+" with "+pxGetBodyName$(pxContactGetBody(DynBody1, contactnumber))
;		If ForceN#<>0 Then DebugLog "ForceN in contact "+ForceN#
;	Next

	contacts=pxGetContacts%(DynBody2)
	Text 300,10,"Dynamic body 2. Contacts: "+contacts
	For contactnumber=0 To contacts-1
		ForceN#=pxContactGetForceNY#(DynBody2, contactnumber)
		Text 300,30+contactnumber*20,"FN in con# "+contactnumber+" is "+ForceN#+" with "+pxGetBodyName$(pxContactGetBody(DynBody2, contactnumber))
;		If ForceN#<>0 Then DebugLog "ForceN in contact "+ForceN#
;		;contact point
;		NewCone=CopyEntity(contactmesh,ContactPivot)
;		PositionEntity NewCone,pxContactGetPointX#(DynBody2, contactnumber),pxContactGetPointY#(DynBody2, contactnumber),pxContactGetPointZ#(DynBody2, contactnumber)
;		AlignToVector NewCone,pxContactGetPointNX#(DynBody2, contactnumber),pxContactGetPointNY#(DynBody2, contactnumber),pxContactGetPointNZ#(DynBody2, contactnumber),2
	Next

	contacts=pxGetContacts%(StBody)
	Text 600,10,"Static body. Contacts: "+contacts
;	For contactnumber=0 To contacts-1
;		ForceN#=pxContactGetForceNY#(StBody, contactnumber)
;		Text 600,30+contactnumber*20,"FN in con# "+contactnumber+" is "+ForceN#+" with "+pxGetBodyName$(pxContactGetBody(StBody, contactnumber))
;		If ForceN#<>0 Then DebugLog "ForceN in contact "+ForceN#
;	Next
	Text 10,400,pl
	Flip 1
Forever
End


Function CreateTextTexture(sz,val$)
	t=CreateTexture(sz,sz)

	SetBuffer TextureBuffer(t)

	Color 255,255,255
	Rect 0,0,sz,sz
	Color 255,0,0
	Text sz*0.5,sz*0.5,val,1,1

	SetBuffer BackBuffer()

	Color 100,200,100
	
	Return t
End Function 

Function BodyCreateMesh(mesh%)

	nsurf = CountSurfaces(mesh)
	nvert = 0
	nface=0
	For ns = 1 To nsurf
		Local surf = GetSurface(mesh,ns)
		nface = nface+CountTriangles(surf)
		nvert = nvert +CountVertices(surf)
	Next

	fbank = CreateBank(nface*4*3)
	nf = 0
	vbank = CreateBank(nvert*4*3)
	nv = 0
	For ns = 1 To nsurf
		surf = GetSurface(mesh,ns)
		nfv = CountTriangles(surf)
		For nfc = 0 To nfv -1
			PokeInt fbank,nf*12+0,TriangleVertex(surf,nfc,0)
			PokeInt fbank,nf*12+4,TriangleVertex(surf,nfc,1)
			PokeInt fbank,nf*12+8,TriangleVertex(surf,nfc,2)
			nf=nf+1
		Next

		nvv = CountVertices(surf)
		For nvc = 0 To nvv - 1
			PokeFloat vbank,nv*12+0,VertexX(surf,nvc)
			PokeFloat vbank,nv*12+4,VertexY(surf,nvc)
			PokeFloat vbank,nv*12+8,VertexZ(surf,nvc)
			nv = nv+1
		Next
	Next
	bbb%=pxCreateTriMesh(vbank, fbank, nvert, nface,0)
	FreeBank vbank
	FreeBank fbank
	Return bbb%
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D