;by MadMedic

Graphics3D 640, 480,0,2
SetBuffer BackBuffer()
SetFont LoadFont("ourier",16)
Color 255,255,0
;physx init
PxCreateWorld(0, "key")
pxSetGravity(0, -20, 0)

;cam
pivot=CreatePivot()
camera=CreateCamera(pivot) 
PositionEntity camera,0,0,-75
RotateEntity pivot,45,0,0
;light
light=CreateLight()

;create level
level = LoadMesh ("..\media\002.b3d")
PositionMesh level, 0,0,0
ScaleMesh level,3,3,3
bbb=BodyCreateMesh%(level)
pxBodySetBodyUserData(bbb, level)

;explode magnet
EdExploMagnet=pxCreateMagnet%(1,0,1000)
pxMagnetSetPosition(EdExploMagnet,-20,0,0)
pxMagnetSetMaxRadius(EdExploMagnet, 20)
pxMagnetSetMinForce(EdExploMagnet, 1)
pxMagnetSetMidForce(EdExploMagnet, 0)
pxMagnetSetMaxForce(EdExploMagnet, -750)
pxMagnetSetMask(EdExploMagnet, 3)	;mask Bin(11)

EdExploSphere=CreateSphere()
EntityAlpha EdExploSphere,0.1
EntityFX EdExploSphere,1+16
EntityColor EdExploSphere,155,0,0
PositionEntity EdExploSphere,-20,0,0
ScaleEntity EdExploSphere,20,20,20


;just magnet
Magnet=pxCreateMagnet%(1,0,1000)
pxMagnetSetPosition(Magnet,20,0,0)
pxMagnetSetMaxRadius(Magnet, 20)
pxMagnetSetMinForce(Magnet, 100)
pxMagnetSetMidForce(Magnet, 150)
pxMagnetSetMaxForce(Magnet, 200)
pxMagnetSetMask(Magnet, 2)	;mask Bin(10)

MagnetSphere=CreateSphere()
EntityAlpha MagnetSphere,0.1
EntityFX MagnetSphere,1+16
EntityColor MagnetSphere,0,0,155
PositionEntity MagnetSphere,20,0,0
ScaleEntity MagnetSphere,20,20,20

;cubes
For i=1 To 60
Create_Px_Cube(Rnd(-35,35),Rnd(20,40),Rnd(-20,30))
Next

MoveMouse 320,240
FlushMouse()


While Not KeyDown( 1 )

	;mouse rotate
	If MouseDown(2)
		TurnEntity pivot,MouseYSpeed(),0,0
		TurnEntity pivot,0,-MouseXSpeed(),0,1
		MoveMouse 320,240
	EndIf
	MoveEntity camera,0,0,MouseZSpeed()*10
	MouseXSpeed():MouseYSpeed()

	If KeyHit(57) Cube_rekid()

	If KeyHit(2) pxMagnetActivate(EdExploMagnet,0,1)
	If KeyDown(3) pxMagnetActivate(Magnet,0,0)
	
	;update px
	pxRenderPhysic(60,0)
	Update_Px_Cube()

	UpdateWorld ()
	RenderWorld

Text 10,10,"1/2 - activate Magnet"
Text 10,30,"space - reset"
Flip 1
Wend 

End


Type Px_Cube
	Field cube_body%
	Field cube_mesh%
End Type

Function Create_Px_Cube(x,y,z)
	ocu.Px_Cube=New Px_Cube
	ocu\cube_body=PxBodyCreateCube(2,2,2, 1)
	ocu\cube_mesh=CreateCube()
	ScaleEntity ocu\cube_mesh,2,2,2
	pxBodySetPosition(ocu\cube_body, x, y, z)
	pxBodySetRotation(ocu\cube_body,Rand(-90,90),Rand(-90,90),Rand(-90,90))
	pxBodySetBodyUserData(ocu\cube_body, ocu\cube_mesh)

	Metall=Rand(0,1)
	If Metall
		EntityColor ocu\cube_mesh,230,232,215
		EntityShininess ocu\cube_mesh,1
		pxBodySetMagnetMask(ocu\cube_body, 2) ;bin(10)
	Else
		EntityColor ocu\cube_mesh,128,64,64
		pxBodySetMagnetMask(ocu\cube_body, 1) ;bin(01)
	EndIf
 End Function
Function Update_Px_Cube()
	For ocu.Px_Cube = Each Px_Cube
         pxBodySetEntity(ocu\cube_mesh, ocu\cube_body)
	Next
End Function
Function Cube_rekid()
	For ocu.Px_Cube = Each Px_Cube
		pxBodySetPosition(ocu\cube_body,Rnd(-35,35),Rnd(20,40),Rnd(-35,35))
		pxBodySetRotation(ocu\cube_body,Rand(-90,90),Rand(-90,90),Rand(-90,90))
	Next
End Function
Function BodyCreateMesh(mesh%)

	nsurf = CountSurfaces(mesh)
	nvert = 0
	nface=0
	For ns = 1 To nsurf
		Local surf = GetSurface(mesh,ns)
		nface = nface+CountTriangles(surf)
		nvert = nvert +CountVertices(surf)
	Next

	fbank = CreateBank(nface*4*3)
	nf = 0
	vbank = CreateBank(nvert*4*3)
	nv = 0
	For ns = 1 To nsurf
		surf = GetSurface(mesh,ns)
		nfv = CountTriangles(surf)
		For nfc = 0 To nfv -1
			PokeInt fbank,nf*12+0,TriangleVertex(surf,nfc,0)
			PokeInt fbank,nf*12+4,TriangleVertex(surf,nfc,1)
			PokeInt fbank,nf*12+8,TriangleVertex(surf,nfc,2)
			nf=nf+1
		Next

		nvv = CountVertices(surf)
		For nvc = 0 To nvv - 1
			PokeFloat vbank,nv*12+0,VertexX(surf,nvc)
			PokeFloat vbank,nv*12+4,VertexY(surf,nvc)
			PokeFloat vbank,nv*12+8,VertexZ(surf,nvc)
			nv = nv+1
		Next
	Next
	bbb%=pxCreateTriMesh(vbank, fbank, nvert, nface, 0)
	FreeBank vbank
	FreeBank fbank
	Return bbb%
End Function