;       
;GetCompoundFromMesh(entity%, mass#, dens#, static%)  
;static = 0 -  , static = 1 -  

Function GetCompoundFromMesh(entity%, mass#, dens#)

	Local Comp_amount = 0
	comp_desc = pxCreateCompoundDesc()
	For i=1 To CountChildren(entity)
		child% = GetChild (entity, i)
		child_name$ = EntityName (child)
	
		child_dimens_x# = MeshWidth #(child)*0.5*EntityScaleX#(child)
		child_dimens_y# = MeshHeight #(child)*0.5*EntityScaleY#(child)
		child_dimens_z# = MeshDepth#(child)*0.5*EntityScaleZ#(child)
		
		If Instr(child_name$,"\cu",1) <> 0
			MoveEntity child,0,child_dimens_y#,0
			comp_cube_shape = pxCompoundAddCubeShape(comp_desc, child_dimens_x#, child_dimens_y#, child_dimens_z#)
			pxCompoundSetShapePos (comp_cube_shape, EntityX(child,0), EntityY(child,0), EntityZ(child,0))
			pxCompoundSetShapeRot (comp_cube_shape, EntityPitch (child), EntityYaw (child), EntityRoll (child))
			MoveEntity child,0,-child_dimens_y#,0
			Comp_amount = 1

		Else If Instr(child_name$,"\sp",1) <> 0
			comp_sphere_shape = pxCompoundAddSphereShape(comp_desc, child_dimens_x#)
			pxCompoundSetShapePos (comp_sphere_shape, EntityX(child,0), EntityY(child,0), EntityZ(child,0))
			pxCompoundSetShapeRot (comp_sphere_shape, EntityPitch (child), EntityYaw (child), EntityRoll (child))
			Comp_amount = 1

		Else If Instr(child_name$,"\cap",1) <> 0
			MoveEntity child,0,child_dimens_y#,0
			comp_sphere_shape = pxCompoundAddCapsuleShape(comp_desc, child_dimens_x#, child_dimens_y#*1.7 )
			pxCompoundSetShapePos (comp_sphere_shape, EntityX(child,0), EntityY(child,0), EntityZ(child,0))
			pxCompoundSetShapeRot (comp_sphere_shape, EntityPitch (child), EntityYaw (child), EntityRoll (child))
			MoveEntity child,0,-child_dimens_y#,0
			Comp_amount = 1

		Else If Instr(child_name$,"\hul",1) <> 0
			comp_hull_shape = AddHullShape%(comp_desc, child)
			pxCompoundSetShapePos (comp_hull_shape, EntityX(child,0), EntityY(child,0), EntityZ(child,0))
			pxCompoundSetShapeRot (comp_hull_shape, EntityPitch (child), EntityYaw (child), EntityRoll (child))
			Comp_amount = 1
		EndIf
	Next
	If Comp_amount = 0 RuntimeError "Mesh not Found"
		comp_body = pxCreateCompound(comp_desc, mass)
	pxBodySetPosition(comp_body ,EntityX(entity,1),EntityY(entity,1),EntityZ(entity,1))
	pxBodySetRotation(comp_body ,EntityPitch(entity,1),EntityYaw(entity,1),EntityRoll(entity,1))
	;HideEntity entity
	Comp_amount = 0
	Return comp_body
End Function

Function AddHullShape%(compoundDesc, mesh%)
	Local nsurf = CountSurfaces(mesh)
	Local nvert = 0
	For ns = 1 To nsurf
		Local surf = GetSurface(mesh,ns)
		nvert = nvert + CountVertices(surf)
	Next
	     vbank = CreateBank(nvert*4*3)
	nv = 0
	For ns = 1 To nsurf
		surf = GetSurface(mesh,ns)
		nvv = CountVertices(surf)
		For nvc = 0 To nvv - 1
			 PokeFloat vbank,nv*12+0,VertexX(surf,nvc)
			 PokeFloat vbank,nv*12+4,VertexY(surf,nvc)
			 PokeFloat vbank,nv*12+8,VertexZ(surf,nvc)
			nv = nv+1
		Next
	Next
	Local bbb%= pxCompoundAddHullShape(compoundDesc, vbank, nvert)
	FreeBank vbank
	Return bbb
End Function

Function EntityScaleX#(ent%) 
 row=0
 el1# = GetMatElement(ent,row,0) 
 el2# = GetMatElement(ent,row,1) 
 el3# = GetMatElement(ent,row,2) 
 Return Sqr(el1*el1+el2*el2+el3*el3) 
End Function

Function EntityScaleY#(ent%) 
 row=1
 el1# = GetMatElement(ent,row,0) 
 el2# = GetMatElement(ent,row,1) 
 el3# = GetMatElement(ent,row,2) 
 Return Sqr(el1*el1+el2*el2+el3*el3) 
End Function

Function EntityScaleZ#(ent%) 
 row=2
 el1# = GetMatElement(ent,row,0) 
 el2# = GetMatElement(ent,row,1) 
 el3# = GetMatElement(ent,row,2) 
 Return Sqr(el1*el1+el2*el2+el3*el3) 
End Function

